#define BM_CONTINUE 0
#define BM_END_OK   1
#define BM_END_TOTAL_SIZE 2
#define BM_END_CHUNK_SIZE 3

/*
   bm_rawread_16 : could be later improved for a real 16 bits reading
   in the bram
*/
bm_rawread_16(offset)
     int offset;
{
  return bm_rawread(offset) + (bm_rawread(offset+1) << 8);
}

/*
read_bram_raw(offset)
     int offset;
{
#asm
    clc
    adc #$80
    sta __ptr+1
    sax
    sta __ptr
    sei
    tma #4
    pha
    lda #$f7
    tam #4
    csl

    lda [__ptr]
    sax

    csh
    pla
    tam #4
    cli
    cla
#endasm
}
*/

/*
write_bram_raw(value, offset)
     char value;
     int offset;
{
#asm
  __popw
    sxy
    clc
    adc #$80
    sta __ptr+1
    sax
    sta __ptr
    sei
    tma #4
    pha
    lda #$f7
    tam #4
    csl

    say
    sta [__ptr]

    csh
    pla
    tam #4
    cli
    cla
#endasm
}
*/

formatted()
{
  return ((bm_rawread(0) == 0x48) &&
	  (bm_rawread(1) == 0x55) &&
	  (bm_rawread(2) == 0x42) &&
	  (bm_rawread(3) == 0x4D));
}

/* free_space : computes the free remaining space in the bram.
   return the value in bytes or 0xFFFF in case of error (corrupted or non
   formatted)
*/
free_space()
{
  int begin, end;

  begin = bm_rawread(6) + (bm_rawread(7) << 8);
  end = bm_rawread(4) + (bm_rawread(5) << 8);
  end -= begin;
  if ((end -= 0x12) < 0)
    end = 0xFFFF;
  
  return end;
}

int bm_end; /* in raw address */

char file_name[11];
int file_size;
int file_crc;
int file_xx;
int file_data;
int file_pointer;


init_file_list()
{
  char i;
  for (i = 0; i < 11; i++)
    {
      file_name[i] = 0;
    }
  file_pointer = 0x10;
}

next_file()
{
  char i;
      
  file_size = bm_rawread_16(file_pointer);
  if (file_pointer >= bm_end)
    {
      if (file_size == 0)
	return BM_END_OK; /* normal end of bram, both indicators agree */
      else
	return BM_END_TOTAL_SIZE; /* abnormal end of bram, only the 
				     total size variable reports so (we can
				     continue to parse files thought)
				  */
    }

  if (file_size ==0)
    return BM_END_CHUNK_SIZE; /* abnormal end of bram, only the chunk size
				 reports so (we can't continue to parse)
			      */
  file_crc = bm_rawread_16(file_pointer + 2);
  file_xx = bm_rawread_16(file_pointer + 4);
  for (i = 0; i < 10; i++)
    file_name[i] = bm_rawread(i + file_pointer + 6);
  file_data = file_pointer + 0x10;
  file_pointer += file_size;
  return BM_CONTINUE;
}

file_nb(nb)
     int nb;
{
  char error;
  init_file_list();
  error = next_file();
  while ((nb--) && (error == BM_CONTINUE))
    error = next_file();
  return error;
}

total_file()
{
  int size;
  init_file_list();
  size = 0;
  while (next_file() == BM_CONTINUE)
    size++;
  return size;
}

