#include <stdio.h>
#include <stdlib.h>

#define COMPILE_ISO 0
#define COMPILE_ARG "-compile"

void print_usage(char* exe_name)
{
#if defined(COMPILE_ISO)
printf("\
---[ USAGE ]------------------------------------------------------------------\n\
  %s [%s] <input filename 1> [<input filename ...>]\n\
  Produces a file 'filedata.dat' suitable to produce a file restoration cd\n\
  Each file passed as argument must have been produced by 'pcetohd'\n\
  if %s is given as first arg, an iso is also created to restore\n\
  the given files\n",
  exe_name,COMPILE_ARG,COMPILE_ARG);
#else
printf("\
---[ USAGE ]------------------------------------------------------------------\n\
  %s <input filename 1> [<input filename ...>]\n\
  Produces a file 'filedata.dat' suitable to produce a file restoration cd\n\
  Each file passed as argument must have been produced by 'pcetohd'\n",
  exe_name);
#endif
}

void print_contact()
{
printf("\
---[ CONTACT ]----------------------------------------------------------------\n\
  Written by Zeograd <zeograd@zeograd.com>\n\
  Plenty of pc engine stuff can be found on http://www.zeograd.com\n\
  Greetings to : David Shadoff, David Michel, Gravis, Raph, Fag, SirJaguar,\n\
  Eagan, Bt, Namco, CrackLtd, Scooby, Titi and all the pc engine scene\n");

}

void output_c(FILE *out, char c)
{
  static char column = 0;
  fprintf(out, "0X%02X, ", c & 0xff);
  ++column;
  column &= 7;
  if (!column)
    fprintf(out, "\n");

}

int main(int argc, char* argv[])
{
  char compile;

  if (argc < 2)
    print_usage(argv[0]);
  else
#if defined(COMPILE_ISO)
  {
    compile = (strcmp(argv[1],COMPILE_ARG) == 0);
    if (compile && (argc < 3))
      print_usage(argv[0]);
    else
#endif
    {
      int i;
      FILE *out = fopen("filedata.dat", "wb");
      if (out == NULL)
      {
	fprintf(stderr,"Couldn't open file 'filedata.dat' for output\n");
	exit(2);
      }

      fprintf(out,"const char bram_data[] = {\n");

      #if defined(COMPILE_ISO)
      if (strcmp(argv[1], COMPILE_ARG) == 0)
	i = 2;
      else
	i = 1;
      #else
      i = 1;
      #endif

      for (; i < argc; i++)
	{
	FILE *in = fopen(argv[i], "rb");

	if (in == NULL)
	{
	  fprintf(stderr,"Couldn't open file '%s' for input\n", argv[i]);
	  exit(1);
	}

	printf("Processing %s ...\n", argv[i]);

	while (!feof(in))
	{
	  int value = fgetc(in);
	  if (value != EOF)
	    output_c(out, (char)value);
	}

	fclose(in);
      }

      fprintf(out,"\n0X00, 0X00\n};\n");
      fclose(out);

#if defined(COMPILE_ISO)

      if (compile)
      {
	#if defined(UNIX)

	#elsif defined(_WIN32)
	printf("Compiling...");
	system("huc.exe -overlay -scd nanami.c");
	execlp("huc.exe","huc.exe","-overlay","-scd","nanami_menu.c",NULL);
	execlp("huc.exe","huc.exe","-overlay","-scd","bramrest.c",NULL);
	execlp("isolink.exe","isolink.exe","nanami.iso","nanami_menu.ovl",
	  "bramrest.ovl", "nanami.ovl", NULL);
	#endif

      }

    }
#endif
  }

  print_contact();
  exit(0);
}
