/*
  thanks to fagemul, NaMcO, CrackLtd for their sample bram dumps
*/

#include "huc.h"

#define FILE_PER_PAGE 10
#define MENU_Y_OFFSET 8

#define INIT_X 2
#define INIT_Y 3

#define HEADER_X 6
#define HEADER_Y 1

#define ENCODING_PLAIN 0

char current_encoding;
int size_for_header;

#include "bramutil.c"

menu_disp(choice)
     int choice;
{
  int i,j,page;
  char error;

  page = choice / FILE_PER_PAGE;

  error = file_nb(i = page * FILE_PER_PAGE);

  for (j=0; j <FILE_PER_PAGE; i++, j++)
    {

      if (error != BM_CONTINUE)
      {
	put_string("  --ooOOoo--            ", 0, j + MENU_Y_OFFSET);
	continue;
      }
      else
      {
	put_string(file_name, 2, j + MENU_Y_OFFSET);
	put_char('(', 13, j + MENU_Y_OFFSET);
	put_char(')', 18, j + MENU_Y_OFFSET);
	put_hex(file_xx, 4, 14, j + MENU_Y_OFFSET);
	put_hex(file_size, 4, 20, j + MENU_Y_OFFSET);
	put_hex(file_pointer, 4, 25, j + MENU_Y_OFFSET);
      }

      if (i == choice)
	put_string(">", 0, j + MENU_Y_OFFSET);
      else
	put_string(" ", 0, j + MENU_Y_OFFSET);

      error = next_file();
    }
}

#include "convert1.c"

convert_dump_bram_header()
{
  switch (current_encoding)
  {
    case ENCODING_PLAIN:
      return convert_dump_bram_header_1();
    default:
      return 0;
  }
}

convert_dump_bram_size(begin, end)
int begin, end;
{
  switch (current_encoding)
  {
    case ENCODING_PLAIN:
      return convert_dump_bram_size_1(begin,end);
    default:
      return 0;
  }
}

convert_dump_bram(begin, end)
int begin, end;
{
  switch (current_encoding)
  {
    case ENCODING_PLAIN:
      return convert_dump_bram_1(begin,end);
    default:
      return 0;
  }
}

dump_bram(begin,end)
     int begin,end;
{
  int page_begin, page_end, page, page_max, temp, old_temp;
  char joy_status;

  page_begin = begin;
  page_end = end;

  size_for_header = end - begin;

  page = 0;
  page_max = -1;
  temp = begin;
  while (temp < end)
  {
    temp += convert_dump_bram_size(temp, end);
    ++page_max;
  }

  if (page_end > page_begin + convert_dump_bram_size(page_begin, page_end))
    page_end = page_begin + convert_dump_bram_size(page_begin, page_end);

  for (;;)
  {
    cls();
    convert_dump_bram_header();
    convert_dump_bram(page_begin, page_end);
    /*
    put_hex(page_begin, 4, 15, 0);
    put_hex(page_end, 4, 20, 0);
    put_hex(begin, 4, 15, 1);
    put_hex(end, 4, 20, 1);
    put_hex(convert_dump_bram_size(page_begin, page_end), 4, 5, 0);
    */
    put_number(page, 3, 15, 20);
    put_number(page_max, 3, 20, 20);
    put_char('/', 20, 20);

    do {
      vsync(1);
      joy_status = joytrg(0);
    } while (!joy_status);

    if (joy_status & JOY_B)
    {
      return;
    }
    else if (joy_status & JOY_LEFT)
    {
      if (page_begin > begin)
      {
	temp = begin;
	old_temp = begin;
	while (temp < page_begin)
	{
	  old_temp = temp;
	  temp += convert_dump_bram_size(temp, end);
	}
	page_begin = old_temp;
	--page;
      }
      page_end = page_begin + convert_dump_bram_size(page_begin, end);
    }
    else if ((joy_status & JOY_RGHT) || (joy_status & JOY_A))
    {
      if (page_end < end)
      {
	page_begin += convert_dump_bram_size(page_begin, end);
	++page;
      }
      page_end = page_begin + convert_dump_bram_size(page_begin, end);
    }
  }
}

show_header()
{
	put_string("File extraction", 7, 1);
	put_number(total_file(), 2, 3, 4);
	put_string("files(s) on BRAM", 6, 4);
	put_string("Name    ( ID ) Size", 5, 6);
}

#defpal(bw_col,0x000, 0x777);

main ()
{

  char x,y,joy_status;
  int temp;
  char error;
  int menu_current_choice, menu_max_choice;

  cls();
  set_screen_size(SCR_SIZE_32x32);
  set_font_pal(0);
  set_font_color(1,0);
  set_bgpal(0, bw_col);
  cls();
  load_default_font();

  bm_end = bm_rawread_16(4) - 0x8000;

  init_file_list();

  menu_max_choice = total_file();
  menu_current_choice = 0;
  current_encoding = ENCODING_PLAIN;

  show_header();

  for (;;)
    {
      menu_disp(menu_current_choice);

      do {
	vsync(1);
	joy_status = joytrg(0);
      } while (!joy_status);

      if (joy_status & JOY_DOWN)
	{
	if (menu_current_choice < menu_max_choice - 1)
	  menu_current_choice++;
	}
      else if (joy_status & JOY_UP)
	{
	  if (menu_current_choice != 0)
	    menu_current_choice--;
	}
      else if (joy_status & JOY_A)
	{
	  file_nb(menu_current_choice);
	  cls();
	  dump_bram(file_data - 0x10, file_data + file_size - 0x10);
	  cls();
	  show_header();
	}
      #ifdef CD_VERSION
      else if (joy_status & JOY_B)
	cd_execoverlay(OVL_MENU);
      #endif
    }
}
