#include "pcetohd.h"
#include "plain.h"

char transformed_buffer[256];
FILE* in = NULL;

void (*parse_intermediate_form[NB_PARSER])(FILE*) =
  {
    parse_plain
  };

char char_accepted(char c)
{
  return isalpha(c) || isdigit(c);
}

char* readline()
{
  char read_buffer[256];
  int index_in, index_out;

  if (in == NULL)
    fgets(read_buffer, 255, stdin);
  else
  {
    fgets(read_buffer, 255, in);
    fprintf(stdout,"read from file\n");
  }

  for (index_in = 0, index_out = 0; index_in < strlen(read_buffer); index_in++)
    if (char_accepted(read_buffer[index_in]))
      transformed_buffer[index_out++] = read_buffer[index_in];

  transformed_buffer[index_out] = '\0';

  return transformed_buffer;
}

void print_usage(char* exe_name)
{
printf("\
---[ USAGE ]------------------------------------------------------------------\n\
  %s <output filename> [<input filename>]\n\
  If no file where to read data is given, standard input is used\n",
  exe_name);

}

void print_contact()
{
printf("\
---[ CONTACT ]----------------------------------------------------------------\n\
  Written by Zeograd <zeograd@zeograd.com>\n\
  Plenty of pc engine stuff can be found on http://www.zeograd.com\n\
  Greetings to : David Shadoff, David Michel, Gravis, Raph, Fag, SirJaguar,\n\
  Eagan, Bt, Namco, CrackLtd, Scooby, Titi and all the pc engine scene\n");

}

int main(int argc, char* argv[])
{
  char current_encoding;

  if ((argc < 2) || (argc > 3))
    print_usage(argv[0]);
  else
  {
    FILE* out = fopen(argv[1],"wb");
    if (out == NULL)
      {
	fprintf(stderr, "Couldn't open file '%s' for output\n", argv[1]);
	exit(1);
      }

    if (argc == 3)
      {
	in = fopen(argv[2],"rt");
	if (in == NULL)
	{
	  fprintf(stderr, "Couldn't open file '%s' for input\n", argv[2]);
	  exit(3);
	}
      }

    printf("Enter the header of the dump (available on all page) :\n");
    sscanf(readline(),"%02X",&current_encoding);

    if (current_encoding < NB_PARSER)
      (*parse_intermediate_form[current_encoding])(out);
    else
      {
	fprintf(stderr,"Unknown encoding (%d)\n",current_encoding);
	exit(2);
      }

    fclose(out);
    if (argc == 3)
      fclose(in);

    printf(" ** DONE **\n");
  }

  print_contact();
  exit(0);

}
