#include "plain.h"

#define BYTES_PER_PAGE (16 * 16 / 2)
#define BYTES_PER_LINE (16 / 2)
#define LINE_PER_PAGE 16

void ask_line(FILE* out, int line)
{
  int t[8], index;
  printf("Line %2d: ",line);
  readline();
  sscanf(transformed_buffer,
	"%02X%02X%02X%02X%02X%02X%02X%02X",
	t,
	t+1,
	t+2,
	t+3,
	t+4,
	t+5,
	t+6,
	t+7);

  for (index = 0; index < 8; index++)
    fputc(t[index],out);

}

void parse_plain(FILE* out)
{
  unsigned int encoding = 0, size = 0;
  int line = 0;
  int page = 0;
  int page_max;
  int remaining_lines;
  int remaining_bytes;

  sscanf(transformed_buffer, "%02X%04X", &encoding, &size);
  fprintf(stderr, "Encoding: %d\nSize of data: %d bytes\n", encoding, size);

  page_max = size / BYTES_PER_PAGE;
  remaining_lines = (size % BYTES_PER_PAGE) / BYTES_PER_LINE;
  remaining_bytes = (size % BYTES_PER_PAGE) % BYTES_PER_LINE;

  fprintf(stderr, "Full pages: %d\nRemaining full lines: %d\nRemaining bytes: %d\n",
	  page_max,
	  remaining_lines,
	  remaining_bytes);

  for (page = 0; page < page_max; page++)
  {
    printf(" -- Page %d --\n",page);
    for (line = 0; line < LINE_PER_PAGE; line++)
      ask_line(out, line);
  }

  if ((remaining_lines != 0) || (remaining_bytes != 0))
    printf(" -- Last page --\n");

  for (line = 0; line < remaining_lines; line++)
    ask_line(out, line);

  if (remaining_bytes)
  {
    int t, index;
    printf("Last line (%d byte%s) : ",remaining_bytes,remaining_bytes?"s":"");
    fflush(stdin);
    readline();
    for (index = 0; index < remaining_bytes; index++)
    {
      sscanf(transformed_buffer + (index * 2), "%02X",&t);
      fputc(t, out);
    }

  }

}
